package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLASTNode_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLASTNode extends JNIObject  {
	
	/* @generated */
	protected ISLASTNode(long ptr) {
		/*** PROTECTED REGION ID(ISLASTNode_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	static ISLASTNode build(long ptr) {
		if (isISLASTBlockNode(ptr)) {
			return new ISLASTBlockNode(ptr);
		} else 
		if (isISLASTForNode(ptr)) {
			return new ISLASTForNode(ptr);
		} else 
		if (isISLASTIfNode(ptr)) {
			return new ISLASTIfNode(ptr);
		} else 
		if (isISLASTMarkNode(ptr)) {
			return new ISLASTMarkNode(ptr);
		} else 
		if (isISLASTUnscannedNode(ptr)) {
			return new ISLASTUnscannedNode(ptr);
		} else 
		if (isISLASTUserNode(ptr)) {
			return new ISLASTUserNode(ptr);
		} else 
		{
			return new ISLASTNode(ptr);
		}
	}
	//Instance of methods for subclasses
	/* @generated */
	private static boolean isISLASTBlockNode(long ptr) {
		if (ISLNative.isl_ast_node_is_block(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLASTBlockNode() {
		return isISLASTBlockNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLASTForNode(long ptr) {
		if (ISLNative.isl_ast_node_is_for(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLASTForNode() {
		return isISLASTForNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLASTIfNode(long ptr) {
		if (ISLNative.isl_ast_node_is_if(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLASTIfNode() {
		return isISLASTIfNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLASTMarkNode(long ptr) {
		if (ISLNative.isl_ast_node_is_mark(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLASTMarkNode() {
		return isISLASTMarkNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLASTUnscannedNode(long ptr) {
		if (ISLNative.isl_ast_node_is_unscanned(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLASTUnscannedNode() {
		return isISLASTUnscannedNode(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLASTUserNode(long ptr) {
		if (ISLNative.isl_ast_node_is_user(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLASTUserNode() {
		return isISLASTUserNode(getNativePtr(this));
	}
	
	/*** PROTECTED REGION ID(ISLASTNode_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_ast_build_ast_from_schedule 
	 * 
	@take schedule
	 * @generated
	**/
	 public static ISLASTNode buildFromSchedule(ISLASTBuild build, ISLUnionMap schedule) { 
		/*** PROTECTED REGION ID(static_isl_ast_build_ast_from_schedule) DISABLED START ***/
		ISLASTNode res;
		
		synchronized(LOCK) {
			checkParameters(schedule);
			try {
				res = ISLASTNode.build(ISLNative.isl_ast_build_ast_from_schedule(getNativePtr(build), getNativePtr(schedule)));
			} finally {
				taken(schedule);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLASTNode node, int format) { 
		/*** PROTECTED REGION ID(static_isl_ast_node_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_ast_node_to_string(getNativePtr(node), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_ast_node_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_ast_node_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_ast_node_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_copy 
	 * 
	 * @generated
	**/
	public ISLASTNode copy() {
		/*** PROTECTED REGION ID(isl_ast_node_copy) DISABLED START ***/
		ISLASTNode res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTNode.build(ISLNative.isl_ast_node_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_ast_node_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_ast_node_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_get_type 
	 * 
	 * @generated
	**/
	public ISLASTNodeType getType() {
		/*** PROTECTED REGION ID(isl_ast_node_get_type) DISABLED START ***/
		ISLASTNodeType res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTNodeType.build(ISLNative.isl_ast_node_get_type(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_set_annotation 
	 * 
	 * @generated
	**/
	public ISLASTNode setAnnotation(ISLIdentifier annotation) {
		/*** PROTECTED REGION ID(isl_ast_node_set_annotation) DISABLED START ***/
		ISLASTNode res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTNode.build(ISLNative.isl_ast_node_set_annotation(getNativePtr(this), getNativePtr(annotation)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_get_annotation 
	 * 
	 * @generated
	**/
	public ISLIdentifier getAnnotation() {
		/*** PROTECTED REGION ID(isl_ast_node_get_annotation) DISABLED START ***/
		ISLIdentifier res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIdentifier.build(ISLNative.isl_ast_node_get_annotation(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_to_C_str 
	 * 
	 * @generated
	**/
	public String toCString() {
		/*** PROTECTED REGION ID(isl_ast_node_to_C_str) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_ast_node_to_C_str(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLASTNodeVisitor visitor) {
		visitor.visitISLASTNode(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLASTNode_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
